// tutorial3.pike
Stdio.Port mainsock;
int port=1234; //Port number to bind to. Under Unix-like platforms (eg Linux),
//only the superuser can use ports <1024, so let's use a high port number here.

int main()
{
	mainsock=Stdio.Port(port);
	if (mainsock->errno())
	{
		werror("Error binding to port %d: %s\n",
			port,strerror(mainsock->errno()));
		return 1;
	}
	while (Stdio.File sock=mainsock->accept())
	{
		thread_create(handle_client,sock);
	}
	return 0;
}

void handle_client(Stdio.File sock) //Called once for every client who connects.
{
	sock->write("Hello, world!\n"); //Initial greeting to the client.
	string buffer="";
	while (1)
	{
		//Do we have a full line of input?
		if (sscanf(buffer,"%s\n%s",string line,buffer))
		{
			//Yes! We have a command.
			sock->write(line+"\n"); //Echo it back!
		}
		else
		{
			//Nope. Read some data from the client.
			string data=sock->read(1024,1);
			if (!data || data=="") break; //Client has disconnected.
			buffer+=data;
		}
	}
	sock->close();
}

