// tutorial5_client.pike
Stdio.File sock;

void handle_client(Stdio.File s) //Called once for every client who connects.
{
	this->sock=s;
	sock->write("Hello, world!\n"); //Initial greeting to the client.
	string buffer="";
	while (sock->is_open())
	{
		//Do we have a full line of input?
		if (sscanf(buffer,"%s\n%s",string line,buffer))
		{
			//Yes! We have a command.
			//Clean up any leading or trailing whitespace
			line=String.trim_all_whites(line);
			//Divide the line into command and parameters
			sscanf(line,"%s %s",string cmd,string param);
			if (!cmd) {cmd=line; param="";}
			//Handle the command.
			object handler=prime->command[cmd];
			if (!handler)
			{
				sock->write("Unknown command '%s'.\n",cmd);
				continue;
			}
			//Call the appropriate routine to handle the command.
			handler->process(this,param);
		}
		else
		{
			//Nope. Read some data from the client.
			string data=sock->read(1024,1);
			if (!data || data=="") break; //Client has disconnected.
			buffer+=data;
		}
	}
	sock->close();
}
