// tutorial6.pike
Stdio.Port mainsock;
int port=1234; //Port number to bind to. Under Unix-like platforms (eg Linux),
//only the superuser can use ports <1024, so let's use a high port number here.
string clientfile="tutorial6_client.pike"; //Use this file for new connections
string cmddir="tutorial6_commands"; //Look for command files in this directory
program client;
mapping(string:object) command=([]);
mapping(string:mixed) data=([]); //For convenience - allow persistent data.

int main()
{
	add_constant("prime",this); //Make this available to the client routine
	load_subprograms();
	//On Linux, respond to SIGHUP to reload:
	signal(1,load_subprograms);
	//On Windows, if this causes trouble, just delete the above line.
	mainsock=Stdio.Port(port);
	if (mainsock->errno())
	{
		werror("Error binding to port %d: %s\n",
			port,strerror(mainsock->errno()));
		return 1;
	}
	while (Stdio.File sock=mainsock->accept())
	{
		object cl=client(); //Instantiate an object from the 'program'.
		thread_create(cl->handle_client,sock);
	}
	return 0;
}

void load_subprograms() //Load every other file we need.
{
	client=compile_file(clientfile); //Compile, save the 'program' object
	foreach (sort(get_dir(cmddir)),string fn) //Iterate over the directory
	{
		sscanf(fn,"%s.pike",string cmd);
		//In contrast to the above, this loads, compiles, and
		//instantiates all in one line.
		command[cmd]=compile_file(combine_path(cmddir,fn))();
	}
}

